tests: correct print_ver_ arguments and add a rule to enforce this
[platform/upstream/coreutils.git] / tests / chown / basic
index 39fad14..6225400 100755 (executable)
@@ -1,11 +1,11 @@
 #!/bin/sh
 # make sure chown --from=... works
 
-# Copyright (C) 2001, 2004, 2006 Free Software Foundation, Inc.
+# Copyright (C) 2001-2012 Free Software Foundation, Inc.
 
-# This program is free software; you can redistribute it and/or modify
+# This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
+# the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 
 # This program is distributed in the hope that it will be useful,
 # GNU General Public License for more details.
 
 # You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
-# 02110-1301, USA.
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-if test "$VERBOSE" = yes; then
-  set -x
-  chgrp --version
-fi
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ chown
+require_root_
 
-. $srcdir/../envvar-check
-. $srcdir/../lang-default
-PRIV_CHECK_ARG=require-root . $srcdir/../priv-check
+touch f || framework_failure_
 
-pwd=`pwd`
-tmp=basic.$$
-trap 'status=$?; cd "$pwd" && rm -rf $tmp && exit $status' 0
-trap '(exit $?); exit' 1 2 13 15
-
-framework_failure=0
-mkdir $tmp || framework_failure=1
-cd $tmp || framework_failure=1
-touch f || framework_failure=1
-
-if test $framework_failure = 1; then
-  echo 'failure in testing framework' 1>&2
-  (exit 1); exit 1
-fi
-
-fail=0
 chown -R --preserve-root 0:1 f
 
 # Make sure the owner and group are 0 and 1 respectively.
-set _ `ls -n f`; shift; test "$3:$4" = 0:1 || fail=1
+set _ $(ls -n f); shift; test "$3:$4" = 0:1 || fail=1
+
+# Make sure the correct diagnostic is output
+# Note we output a name even though an id was specified.
+chown -v --from=42 43 f > out || fail=1
+printf "ownership of 'f' retained as $(id -nu)\n" > exp
+compare exp out || fail=1
+
+# Ensure diagnostics work for non existent files.
+chown -v 0 nf > out && fail=1
+printf "failed to change ownership of 'nf' to 0\n" > exp
+compare exp out || fail=1
 
 chown --from=0:1 2:010 f || fail=1
 
 # And now they should be 2 and 10 respectively.
-set _ `ls -n f`; shift; test "$3:$4" = 2:10 || fail=1
+set _ $(ls -n f); shift; test "$3:$4" = 2:10 || fail=1
 
 ln -s f slink
 # Applying chown to a symlink with --no-dereference
 # should change only the link.
 chown --no-dereference 0:1 slink || fail=1
 # owner/group on the symlink should be set
-set _ `ls -n slink`; shift; test "$3:$4" = 0:1 || fail=1
+set _ $(ls -n slink); shift; test "$3:$4" = 0:1 || fail=1
 # owner/group on the referent should remain unchanged
-set _ `ls -n f`;     shift; test "$3:$4" = 2:10 || fail=1
+set _ $(ls -n f);     shift; test "$3:$4" = 2:10 || fail=1
 
 chown --no-dereference --from=0:1 2:010 slink || fail=1
 # owner/group on the symlink should be changed
-set _ `ls -n slink`; shift; test "$3:$4" = 2:10 || fail=1
+set _ $(ls -n slink); shift; test "$3:$4" = 2:10 || fail=1
 
-(exit $fail); exit $fail
+Exit $fail